{$R-,S-,I-,D-,F-,V-,B-}

unit grafmaus;

{ ͻ }
{  Autor         Anton Liebetrau, Winterthur/Schweiz          }
{  Copyright     1989, Vieweg-Verlag, Wiesbaden/BRD           }
{  Programmname  Turbo Mouse                                  }
{  Beschreibung  Ansteuerung der Maus (Microsoft und komp.)   }
{  Version       1.00                                         }
{  Stand         24. Februar 1989                             }
{ ͼ }

interface
uses
  crt,dos;
const
  LeftBut   = 0;
  RightBut  = 1;
  MiddleBut = 2;
type
  CursorType=array [0..31] of word;

  function MouseReady:boolean;
    { Wahr, wenn Maustreiber installiert }
  procedure InitMouse;
    { Initialisert die Maus }
  procedure MouseOn;
    { Zeigt den Maus-Cursor }
  procedure MouseOff;
    { Versteckt den Maus-Cursor }
  function IsMouseOn:boolean;
    { Prft, ob Mauszeiger sichtbar }
  procedure ConvertOff;
    { Maus-Koordinaten werden in keinem Fall umgewandelt }
  procedure ConvertOn;
    { Maus-Koordinaten werden in Abhngigkeit des aktuellen Bild- }
    { schirm-Modus umgewandelt                                    }
  function IsConvertOn:boolean;
    { Prft, ob Maus-Koordinaten umgewandelt werden }

  procedure GetMousePos(var x,y:integer);
    { Ermittelt die aktuelle Position der Maus }
  procedure SetMousePos(x,y:integer);
    { Setzt die Maus an den Punkt <x,y> }
  procedure GetClickPos(var x,y,click:integer; button:word);
    { Ermittelt den Punkt, bei dem eine Maustaste gedrckt wurde }
  procedure GetReleasePos(var x,y,click:integer; button:word);
    { Ermittelt den Punkt, bei dem eine Maustaste losgelassen wurde }
  procedure SetMouseRange(x1,y1,x2,y2:integer);
    { Definiert einen Bereich, in dem sich die Maus bewegen darf }
  function MouseActRange(x1,y1,x2,y2:integer):boolean;
    { Prft, ob sich die aktuelle Mausposition in einem rechteckigen }
    { Ausschnitt befindet                                            }
  function MouseRange(xm,ym,x1,y1,x2,y2:integer):boolean;
    { Prft, ob sich der Punkt (xm,ym) in einem rechteckigen Ausschnitt }
    { befindet                                                          }

  function Buttons:word;
    { Ermittelt die Anzahl der verfgbaren Maustasten }
  function LeftButton:boolean;
    { Wahr, wenn die linke Maustaste gedrckt wird }
  function RightButton:boolean;
    { Wahr, wenn die rechte Maustaste gedrckt wird }
  function MiddleButton:boolean;
    { Wahr, wenn die mittlere Maustaste gedrckt wird }
  function AnyButton:boolean;
    { Wahr, wenn eine beliebige Maustaste gedrckt wird }
  function DoubleClick(button,time:word):boolean;
    { Wahr, wenn in einer gewissen Zeitspanne eine Maustaste zwei }
    { Mal gedrckt wird                                           }
  function SingleClick(button,time:word):boolean;
    { Wahr, wenn in einer gewissen Zeitspanne eine Maustaste ge-  }
    { nau ein Mal gedrckt wird                                   }

  procedure SetGraphCursor(x,y:integer; var cursor);
    { Definiert einen neuen Graphik-Cursor }
  procedure SetTextCursor(ch:char);
    { Definiert einen neuen Text-Cursor }
  procedure SetMouseStyle(style:word);
    { Definiert einen vorgegebenen Graphik-Cursor }

  procedure SetRatio(x,y:integer);
    { Definiert die Auswirkung einer Mausbewegung }
  procedure SetThreshold(speed:word);
    { Legt fest, wann die Geschwindigkeit des Mauszeigers verdoppelt }
    { werden soll                                                    }
  procedure GetMotion(var dx,dy:integer);
    { Ermittelt die relative Bewegung der Maus }
  procedure MouseCondOff(x1,y1,x2,y2:integer);
    { Schaltet den Mauszeiger aus, wenn er in einen gewissen Bereich }
    { kommt                                                          }

implementation
const
  c00:cursortype=  { blicher Mauszeiger }
    ($3FFF,$1FFF,$0FFF,$07FF,$03FF,$01FF,$00FF,$007F,
     $003F,$001F,$000F,$00FF,$10FF,$787F,$F87F,$FC7F,
     $0000,$4000,$6000,$7000,$7800,$7C00,$7E00,$7F00,
     $7F80,$7FC0,$7E00,$4600,$0600,$0300,$0300,$0000);
  c01:cursortype=  { Pfeil auf/ab }
    ($FEFF,$FC7F,$F83F,$F01F,$E00F,$C007,$8003,$F83F,
     $F83F,$8003,$C007,$E00F,$F01F,$F83F,$FC7F,$FEFF,
     $0000,$0100,$0380,$07C0,$0FE0,$1FF0,$0380,$0380,
     $0380,$0380,$1FF0,$0FE0,$07C0,$0380,$0100,$0000);
  c02:cursortype=  { Pfeil links/rechts }
    ($FFFF,$FDBF,$F99F,$F18F,$E187,$C003,$8001,$0000,
     $8001,$C003,$E187,$F18F,$F99F,$FDBF,$FFFF,$FFFF,
     $0000,$0000,$0000,$0420,$0C30,$1C38,$3FFC,$7FFE,
     $3FFC,$1C38,$0C30,$0420,$0000,$0000,$0000,$0000);
  c03:cursortype=  { Pfeil ab }
    ($F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,
     $0001,$8003,$C007,$E00F,$F01F,$F83F,$FC7F,$FEFF,
     $0000,$0380,$0380,$0380,$0380,$0380,$0380,$0380,
     $0380,$3FF8,$1FF0,$0FE0,$07C0,$0380,$0100,$0000);
  c04:cursortype=  { Pfeil links }
    ($FEFF,$FCFF,$F8FF,$F0FF,$E0FF,$C000,$8000,$0000,
     $8000,$C000,$E0FF,$F0FF,$F8FF,$FCFF,$FEFF,$FFFF,
     $0000,$0000,$0200,$0600,$0E00,$1E00,$3FFE,$7FFE,
     $3FFE,$1E00,$0E00,$0600,$0200,$0000,$0000,$0000);
  c05:cursortype=  { Pfeil auf }
    ($FEFF,$FC7F,$F83F,$F01F,$E00F,$C007,$8003,$0001,
     $F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,$F83F,
     $0000,$0100,$0380,$07C0,$0FE0,$1FF0,$3FF8,$0380,
     $0380,$0380,$0380,$0380,$0380,$0380,$0380,$0000);
  c06:cursortype=  { Pfeil rechts }
    ($FF7F,$FF3F,$FF1F,$FF0F,$FF07,$0003,$0001,$0000,
     $0001,$0003,$FF07,$FF0F,$FF1F,$FF3F,$FF7F,$FFFF,
     $0000,$0000,$0040,$0060,$0070,$0078,$7FFC,$7FFE,
     $7FFC,$0078,$0070,$0060,$0040,$0000,$0000,$0000);
  c07:cursortype=  { Pfeil auf/ab/links/rechts }
    ($FEFF,$FC7F,$F83F,$F01F,$E00F,$C007,$8003,$0001,
     $8003,$C007,$E00F,$F01F,$F83F,$FC7F,$FEFF,$FFFF,
     $0000,$0100,$0380,$07C0,$0100,$1110,$3118,$7FFC,
     $3118,$1110,$0100,$07C0,$0380,$0100,$0000,$0000);
  c08:cursortype=  { Pfeil, 4 Richtungen, schrg }
    ($0001,$0001,$0001,$0001,$0001,$0001,$0001,$0001,
     $0001,$0001,$0001,$0001,$0001,$0001,$0001,$FFFF,
     $0000,$7C7C,$783C,$783C,$7C7C,$4EE4,$07C0,$0380,
     $07C0,$4EE4,$7C7C,$783C,$783C,$7C7C,$0000,$0000);
  c09:cursortype=  { Kreuz }
    ($FC7F,$FC7F,$FC7F,$FC7F,$FC7F,$FD7F,$0381,$07C1,
     $0381,$FD7F,$FC7F,$FC7F,$FC7F,$FC7F,$FC7F,$FFFF,
     $0000,$0100,$0100,$0100,$0100,$0100,$0100,$7FFC,
     $0100,$0100,$0100,$0100,$0100,$0100,$0000,$0000);
  c10:cursortype=  { Kreuz mit Kreis }
    ($FC7F,$FC7F,$FC7F,$FC7F,$FC7F,$F83F,$0001,$0001,
     $0001,$F83F,$FC7F,$FC7F,$FC7F,$FC7F,$FC7F,$FFFF,
     $0000,$0100,$0100,$0100,$0100,$0380,$06C0,$7C7C,
     $06C0,$0380,$0100,$0100,$0100,$0100,$0000,$0000);
  c11:cursortype=  { Kreuz mit Rand }
    ($F01F,$F01F,$F01F,$F01F,$0003,$0001,$0000,$0000,
     $0000,$0000,$0000,$F000,$F00F,$F00F,$F80F,$FC0F,
     $0000,$07C0,$0440,$0440,$0440,$7C7C,$4006,$4006,
     $4006,$7C7E,$047E,$0460,$0460,$07E0,$03E0,$0000);
  c12:cursortype=  { Sanduhr }
    ($0000,$0000,$8001,$C003,$E007,$F00F,$F81F,$FC3F,
     $F81F,$F00F,$E007,$C003,$8001,$0000,$0000,$FFFF,
     $0000,$7FFE,$300C,$1818,$0C30,$0660,$03C0,$0180,
     $03C0,$0660,$0C30,$1998,$33CC,$7FFE,$0000,$0000);
  c13:cursortype=  { Biene: gezeichnet von Martin Sauter, Winterthur }
    ($FCC7,$F803,$F801,$F801,$F001,$8000,$0000,$0001,
     $8003,$8003,$0003,$0001,$0001,$8001,$C0E3,$F9FF,
     $0000,$0338,$0264,$00C4,$0684,$0E0A,$6D92,$434C,
     $1AE0,$31D8,$60B8,$4274,$456C,$391C,$0600,$0000);
  c14:cursortype=  { Klecks }
    ($FC7F,$FC1F,$600F,$0001,$0000,$8000,$0000,$8000,
     $0000,$0000,$0000,$0002,$4003,$E027,$F83F,$FE7F,
     $0100,$0000,$03E0,$9FF0,$4FFE,$3FFD,$7FFC,$3FFE,
     $7FFE,$7FFC,$FFF9,$9FF8,$17D8,$0480,$0180,$0000);
  c15:cursortype=  { Knopf }
    ($0003,$0001,$0000,$0000,$0000,$0000,$0000,$0000,
     $0000,$0000,$0000,$0000,$0000,$0000,$8000,$C000,
     $0000,$7FFC,$4006,$5556,$4AA6,$5556,$4AA6,$5556,
     $4AA6,$5556,$4AA6,$5556,$4006,$7FFE,$3FFE,$0000);
  c16:cursortype=  { Diskette }
    ($0000,$0000,$0000,$0000,$0000,$0000,$0000,$0180,
     $0180,$0000,$0000,$0000,$0000,$0000,$0000,$0000,
     $0000,$7FFE,$40FE,$5EFE,$40F8,$7FF8,$7E7E,$7C3E,
     $7C3E,$7E7E,$7FEE,$7E7E,$7E7E,$7E7E,$7E7E,$0000);
  c17:cursortype=  { Rechner }
    ($0003,$0001,$0000,$0000,$0000,$0000,$0000,$0000,
     $0000,$0000,$0000,$0000,$0000,$0000,$8000,$C000,
     $0000,$7FFC,$4006,$5C56,$4006,$7FFE,$4006,$5556,
     $4006,$5556,$4006,$5556,$4006,$7FFE,$3FFE,$0000);
  c18:cursortype=  { Spritzpistole }
    ($FFFC,$FFF8,$0000,$0000,$0000,$0000,$0000,$0002,
     $1003,$3003,$F003,$F003,$F003,$F003,$F003,$F003,
     $0001,$0002,$0005,$7FEA,$70C5,$73F2,$73F1,$67F8,
     $47F8,$07F8,$0408,$0408,$0408,$0408,$07F8,$0000);
var
  init,conv,moff:boolean;
  altexit:pointer;
  p:pointer;
  reg:registers;
  but:word;
  screenmode:byte absolute 0:$449;  { aktueller Bildschirm-Modus }

  procedure ConvMinus(var x,y:integer);
    { DIV nicht durch SHR ersetzen, da sonst negative Werte nicht kor- }
    { rekt verarbeitet werden.                                         }
  begin
    if not conv then exit;
    case screenmode of
      0,1:begin x:=succ(x div 16); y:=succ(y div 8) end;
      2,3,7:begin x:=succ(x div 8); y:=succ(y div 8) end;
      4,5:x:=x div 2;
    end
  end;

  procedure ConvPlus(var x,y:integer);
    { Multiplikation nicht durch SHL ersetzen, da sonst negative Werte }
    { nicht korrekt verarbeitet werden.                                }
  begin
    if not conv then exit;
    case screenmode of
      0,1:begin x:=pred(x)*16; y:=pred(y)*8 end;
      2,3,7:begin x:=pred(x)*8; y:=pred(y)*8 end;
      4,5:x:=x*2;
    end
  end;

  function mouseready:boolean;
  begin
    mouseready:=init
  end;

  procedure initmouse;
  begin
    if not init then begin
      but:=0;
      exit
    end;
    reg.ax:=0;
    intr(51,reg);
    init:=reg.ax<>0;
    but:=reg.bx;
    moff:=true
  end;

  procedure mouseon;
  begin
    if not init then exit;
    reg.ax:=1;
    intr(51,reg);
    moff:=false
  end;

  procedure mouseoff;
  begin
    if not init then exit;
    if moff then exit;
    reg.ax:=2;
    intr(51,reg);
    moff:=true
  end;

  function ismouseon:boolean;
  begin
    ismouseon:=not moff
  end;

  procedure converton;
  begin
    conv:=true
  end;

  procedure convertoff;
  begin
    conv:=false
  end;

  function isconverton:boolean;
  begin
    isconverton:=conv
  end;

  procedure getmousepos(var x,y:integer);
  begin
    if not init then begin
      x:=0;
      y:=0;
      exit
    end;
    reg.ax:=3;
    intr(51,reg);
    x:=reg.cx;
    y:=reg.dx;
    convminus(x,y)
  end;

  procedure setmousepos(x,y:integer);
  begin
    if not init then exit;
    convminus(x,y);
    reg.ax:=4;
    reg.cx:=x;
    reg.dx:=y;
    intr(51,reg)
  end;

  procedure getclickpos(var x,y,click:integer; button:word);
  begin
    if not init then begin
      x:=0;
      y:=0;
      click:=0;
      exit
    end;
    reg.ax:=5;
    reg.bx:=button;
    intr(51,reg);
    x:=reg.cx;
    y:=reg.dx;
    click:=reg.bx;
    convminus(x,y)
  end;

  procedure getreleasepos(var x,y,click:integer; button:word);
  begin
    if not init then begin
      x:=0;
      y:=0;
      click:=0;
      exit
    end;
    reg.ax:=6;
    reg.bx:=button;
    intr(51,reg);
    x:=reg.cx;
    y:=reg.dx;
    click:=reg.bx;
    convminus(x,y);
  end;

  procedure setmouserange(x1,y1,x2,y2:integer);
  begin
    if not init then exit;
    convplus(x1,y1);
    convplus(x2,y2);
    reg.ax:=7;
    reg.cx:=x1;
    reg.dx:=x2;
    intr(51,reg);
    reg.ax:=8;
    reg.cx:=y1;
    reg.dx:=y2;
    intr(51,reg)
  end;

  function mouserange(xm,ym,x1,y1,x2,y2:integer):boolean;
  begin
    mouserange:=false;
    if not init then exit;
    if (xm<x1) or (xm>x2) then exit;
    if (ym<y1) or (ym>y2) then exit;
    mouserange:=true
  end;

  function mouseactrange(x1,y1,x2,y2:integer):boolean;
  var
    x,y:integer;
  begin
    getmousepos(x,y);
    mouseactrange:=mouserange(x,y,x1,y1,x2,y2)
  end;

  function leftbutton:boolean;
  begin
    if not init then begin
      leftbutton:=false;
      exit
    end;
    reg.ax:=3;
    intr(51,reg);
    leftbutton:=reg.bx and 1=1
  end;

  function rightbutton:boolean;
  begin
    if not init then begin
      rightbutton:=false;
      exit
    end;
    reg.ax:=3;
    intr(51,reg);
    rightbutton:=reg.bx and 2=2
  end;

  function middlebutton:boolean;
  begin
    if not init then begin
      middlebutton:=false;
      exit
    end;
    reg.ax:=3;
    intr(51,reg);
    middlebutton:=reg.bx and 4=4
  end;

  function anybutton:boolean;
  begin
    if not init then begin
      anybutton:=false;
      exit
    end;
    reg.ax:=3;
    intr(51,reg);
    anybutton:=reg.bx and 7<>0
  end;

  function clockticks:word;
  begin
    reg.ah:=0;
    intr(26,reg);
    clockticks:=reg.dx
  end;

  function doubleclick(button,time:word):boolean;
  var
    b,click,
    start,stop:word;
  begin
    doubleclick:=false;
    if not init then exit;
    start:=clockticks;
    time:=round(time*0.0182);  { Wartezeit in Clock-Ticks }
    b:=1 shl button;
    reg.ax:=6;
    reg.bx:=button;
    intr(51,reg);         { Setzt bereits vorhandene "Clicks" zurck }
    click:=0;
    repeat
      reg.ax:=6;
      reg.bx:=button;
      intr(51,reg);
      inc(click,reg.bx);
      if click>1 then begin doubleclick:=true; exit end;
      if reg.bx>0 then start:=stop; { Mouse-Click ist erfolgt        }
      reg.ax:=3;
      intr(51,reg);
      if reg.bx or b<>b then exit;  { Andere Maustaste wird gedrckt }
      if keypressed then exit;      { Tastatur wurde bentzt         }
      stop:=clockticks
    until abs(stop-start)>time
  end;

  function singleclick(button,time:word):boolean;
  var
    b,start,stop:word;
  begin
    singleclick:=false;
    if not init then exit;
    b:=1 shl button;
    start:=clockticks;
    time:=round(time*0.0182);  { Wartezeit in Clock-Ticks }
    reg.ax:=6;
    reg.bx:=button;
    intr(51,reg);
    repeat
      reg.ax:=6;
      reg.bx:=button;
      intr(51,reg);
      if reg.bx>0 then begin singleclick:=true; exit end;
      reg.ax:=3;
      intr(51,reg);
      if reg.bx or b<>b then exit;
      if keypressed then exit;
      stop:=clockticks
    until abs(stop-start)>time
  end;

  function buttons:word;
  begin
    buttons:=but
  end;

  procedure setgraphcursor(x,y:integer; var cursor);
  begin
    if not init then exit;
    reg.ax:=9;
    reg.bx:=x;
    reg.cx:=y;
    reg.es:=seg(cursor);
    reg.dx:=ofs(cursor);
    intr(51,reg)
  end;

  procedure setmousestyle(style:word);
  begin
    case style of
      0:setgraphcursor(0,0,c00);
      1:setgraphcursor(7,7,c01);
      2:setgraphcursor(7,7,c02);
      3:setgraphcursor(7,15,c03);
      4:setgraphcursor(0,7,c04);
      5:setgraphcursor(7,0,c05);
      6:setgraphcursor(15,7,c06);
      7:setgraphcursor(7,7,c07);
      8:setgraphcursor(7,7,c08);
      9:setgraphcursor(7,7,c09);
     10:setgraphcursor(7,7,c10);
     11:setgraphcursor(7,7,c11);
     12:setgraphcursor(7,7,c12);
     13:setgraphcursor(7,7,c13);
     14:setgraphcursor(7,7,c14);
     15:setgraphcursor(7,7,c15);
     16:setgraphcursor(7,7,c16);
     17:setgraphcursor(7,7,c17);
     18:setgraphcursor(14,3,c18)
    end
  end;

  procedure settextcursor(ch:char);
  begin
    if not init then exit;
    reg.ax:=10;
    reg.bx:=0;               { Software-Cursor  }
    reg.cx:=$7f00;           { Bildschirm-Maske }
    reg.dx:=$7f00+byte(ch);  { Cursor-Maske     }
    intr(51,reg)
  end;

  procedure setratio(x,y:integer);
  begin
    if not init then exit;
    if x=0 then x:=1;
    if y=0 then y:=1;
    reg.ax:=15;
    reg.cx:=x;
    reg.dx:=y;
    intr(51,reg)
  end;

  procedure mousecondoff(x1,y1,x2,y2:integer);
  begin
    if not init then exit;
    convplus(x1,y1);
    convplus(x2,y2);
    reg.ax:=16;
    reg.cx:=x1;
    reg.dx:=y1;
    reg.si:=x2;
    reg.di:=y2;
    intr(51,reg);
    moff:=true
  end;

  procedure getmotion(var dx,dy:integer);
  begin
    if not init then begin
      dx:=0;
      dy:=0;
      exit
    end;
    reg.ax:=11;
    intr(51,reg);
    dx:=reg.cx;
    dy:=reg.dx
  end;

  procedure setthreshold(speed:word);
  begin
    if not init then exit;
    reg.ax:=19;
    reg.dx:=speed;
    intr(51,reg)
  end;

{$F+}
  procedure schluss;
  begin
    initmouse;         { Setzt Mouse-Cursor auf eigene Maske zurck }
    mouseoff;
    exitproc:=altexit  { Ermglicht das Ausfhren weiterer Exit-Prozeduren }
  end;
{$F-}

begin
  but:=0;            { Anzahl Maus-Tasten       }
  conv:=true;        { Konvertierung EIN        }
  moff:=true;        { Mauszeiger ausgeschaltet }
  getintvec(51,p);
  init:=p<>nil;      { Prft, ob Maus-Treiber verfgbar ist }
  initmouse;
  altexit:=exitproc; { Sichert vorhandene Exit-Prozedur     }
  exitproc:=@schluss;
end.